diff --git a/src/common/resources/lang/en_US/guidebook.lang b/src/common/resources/lang/en_US/guidebook.lang
index bb8235815..8c2ce2cd7 100644
--- a/src/common/resources/lang/en_US/guidebook.lang
+++ b/src/common/resources/lang/en_US/guidebook.lang
@@ -7,6 +7,19 @@ guidebook.section.blast_furnace=Blast Smelting
 guidebook.section.trommel=Trommelling
 guidebook.section.search=Search
 
+guidebook.section.search.error.no_recipes=No recipes found :(
+guidebook.section.search.result.found=%s results found.
+guidebook.section.search.info.modifiers.title=Search Modifiers
+guidebook.section.search.info.modifiers.1=§er:...§r: Search for recipes
+guidebook.section.search.info.modifiers.2=§eu:...§r: Search for usages
+guidebook.section.search.info.modifiers.3=§e#:...§r: Search for item group
+guidebook.section.search.info.modifiers.4=§e@namespace§r: Search in
+guidebook.section.search.info.modifiers.5=namespace
+guidebook.section.search.info.modifiers.6=§e@namespace:group§r: Search
+guidebook.section.search.info.modifiers.7=in recipe group
+guidebook.section.search.info.modifiers.8=§e...!§r: Strict search
+guidebook.section.search.info.modifiers.9=§e...§r: General search
+
 guidebook.section.mob.health=Health:
 guidebook.section.mob.score=Score: %s
 guidebook.section.mob.damage=Damage: %s
diff --git a/src/main/java/net/minecraft/client/entity/particle/LeafParticle.java b/src/main/java/net/minecraft/client/entity/particle/LeafParticle.java
index ad3b9990b..2afe69663 100644
--- a/src/main/java/net/minecraft/client/entity/particle/LeafParticle.java
+++ b/src/main/java/net/minecraft/client/entity/particle/LeafParticle.java
@@ -16,7 +16,7 @@ import net.minecraft.core.world.World;
 public class LeafParticle extends Particle {
     public LeafParticle(World world, double x, double y, double z, double xa, double ya, double za) {
         super(world, x, y, z, xa, ya, za);
-        this.tex = TextureRegistry.getTexture("minecraft:block/leaves_oak_fancy");
+        this.tex = TextureRegistry.getTexture("minecraft:block/leaves/oak_fancy");
         this.gravity = 0.125F;
         this.size /= 2.0F;
         this.lifetime *= 16;
diff --git a/src/main/java/net/minecraft/client/entity/particle/NoteParticle.java b/src/main/java/net/minecraft/client/entity/particle/NoteParticle.java
index 42dfd9f8b..5f6fd6dd8 100644
--- a/src/main/java/net/minecraft/client/entity/particle/NoteParticle.java
+++ b/src/main/java/net/minecraft/client/entity/particle/NoteParticle.java
@@ -9,19 +9,19 @@ import net.minecraft.core.world.World;
 public class NoteParticle extends Particle {
     private final float oSize;
 
-    public NoteParticle(World world, double x, double y, double z, double xa, double ya, double za) {
-        this(world, x, y, z, xa, ya, za, 2.0F);
+    public NoteParticle(World world, double x, double y, double z, double xa, double ya, double za, int data) {
+        this(world, x, y, z, xa, ya, za, data, 2.0F);
     }
 
-    public NoteParticle(World world, double x, double y, double z, double xa, double ya, double za, float scale) {
-        super(world, x, y, z, 0.0D, 0.0D, 0.0D);
+    public NoteParticle(World world, double x, double y, double z, double xa, double ya, double za, int data, float scale) {
+        super(world, x, y, z, xa, ya, za);
         this.xd *= 0.01D;
         this.yd *= 0.01D;
         this.zd *= 0.01D;
         this.yd += 0.2D;
-        this.rCol = MathHelper.sin(((float) xa + 0.0F) * MathHelper.PI * 2.0F) * 0.65F + 0.35F;
-        this.gCol = MathHelper.sin(((float) xa + 1f / 3) * MathHelper.PI * 2.0F) * 0.65F + 0.35F;
-        this.bCol = MathHelper.sin(((float) xa + 2f / 3) * MathHelper.PI * 2.0F) * 0.65F + 0.35F;
+        this.rCol = MathHelper.sin(((data / 24f) + 0.0F) * MathHelper.PI * 2.0F) * 0.65F + 0.35F;
+        this.gCol = MathHelper.sin(((data / 24f) + 1f / 3) * MathHelper.PI * 2.0F) * 0.65F + 0.35F;
+        this.bCol = MathHelper.sin(((data / 24f) + 2f / 3) * MathHelper.PI * 2.0F) * 0.65F + 0.35F;
         this.size *= 0.75F;
         this.size *= scale;
         this.oSize = this.size;
diff --git a/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java b/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java
index 4358d47a8..f5a6351f7 100644
--- a/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java
+++ b/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java
@@ -36,7 +36,7 @@ public final class ParticleDispatcher extends Dispatcher<String, ParticleLambda>
         Minecraft mc = Minecraft.getMinecraft(this);
         addDispatch("bubble", (world, x, y, z, motionX, motionY, motionZ, data) -> new BubbleParticle(world, x, y, z, motionX, motionY, motionZ, true));
         addDispatch("smoke", (world, x, y, z, motionX, motionY, motionZ, data) -> new SmokeParticle(world, x, y, z, motionX, motionY, motionX));
-        addDispatch("note", (world, x, y, z, motionX, motionY, motionZ, data) -> new NoteParticle(world, x, y, z, motionX, motionY, motionX));
+        addDispatch("note", (world, x, y, z, motionX, motionY, motionZ, data) -> new NoteParticle(world, x, y, z, motionX, motionY, motionX, data));
         addDispatch("portal", (world, x, y, z, motionX, motionY, motionZ, data) -> new PortalParticle(world, x, y, z, motionX, motionY, motionX));
         addDispatch("explode", (world, x, y, z, motionX, motionY, motionZ, data) -> new ExplodeParticle(world, x, y, z, motionX, motionY, motionX));
         addDispatch("flame", (world, x, y, z, motionX, motionY, motionZ, data) -> new FlameParticle(world, x, y, z, motionX, motionY, motionX, FlameParticle.Type.ORANGE));
diff --git a/src/main/java/net/minecraft/client/gui/achievements/pages/OverworldPage.java b/src/main/java/net/minecraft/client/gui/achievements/pages/OverworldPage.java
index 3dd29cc46..5f48a3708 100644
--- a/src/main/java/net/minecraft/client/gui/achievements/pages/OverworldPage.java
+++ b/src/main/java/net/minecraft/client/gui/achievements/pages/OverworldPage.java
@@ -124,7 +124,7 @@ public class OverworldPage extends AchievementPage {
 
                 for (int rY = y; rY - orgY >= 0; rY--) {
                     if (rY == y) {
-                        layer.put(TextureRegistry.getTexture("minecraft:block/grass_side"), _x - orgX, rY - orgY);
+                        layer.put(TextureRegistry.getTexture("minecraft:block/grass/side"), _x - orgX, rY - orgY);
                     } else {
                         layer.put(null, _x - orgX, rY - orgY);
                     }
@@ -326,7 +326,7 @@ public class OverworldPage extends AchievementPage {
         return 0x00ff00;
     }
 
-    private static final IconCoordinate chest = TextureRegistry.getTexture("minecraft:block/chest_planks_oak_front");
+    private static final IconCoordinate chest = TextureRegistry.getTexture("minecraft:block/chest/planks/front");
     private static final IconCoordinate spawner = getTextureFromBlock(Blocks.MOBSPAWNER);
 
     protected static PageStructure dungeonBrick = new PageStructure(new Object[][][]
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/crafting/CraftingPage.java b/src/main/java/net/minecraft/client/gui/guidebook/crafting/CraftingPage.java
index e70e8cb2c..c96f6759a 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/crafting/CraftingPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/crafting/CraftingPage.java
@@ -36,6 +36,7 @@ import net.minecraft.core.data.registry.recipe.entry.RecipeEntryRepairable;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryScrap;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryUndyeing;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.lang.I18n;
 import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.client.gui.guidebook.GuidebookSlot;
 import org.lwjgl.input.Keyboard;
@@ -114,7 +115,7 @@ public class CraftingPage
     @Override
     protected void renderForeground(TextureManager re, Font fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
         if(recipes.isEmpty()){
-            drawStringCenteredNoShadow(fr,"No recipes found :(" ,x+width/2,y+height/2,0xFF808080);
+            drawStringCenteredNoShadow(fr, I18n.getInstance().translateKey("guidebook.section.search.error.no_recipes"), x+width/2,y+height/2,0xFF808080);
         }
         GuidebookSlot mouseOverSlot = null;
         for (GuidebookSlot slot : slots) {
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/search/SearchPage.java b/src/main/java/net/minecraft/client/gui/guidebook/search/SearchPage.java
index 45f97deee..1a9dd0195 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/search/SearchPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/search/SearchPage.java
@@ -7,6 +7,7 @@ import net.minecraft.client.gui.guidebook.*;
 import net.minecraft.client.render.Font;
 import net.minecraft.client.render.TextureManager;
 import net.minecraft.core.data.registry.recipe.SearchQuery;
+import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.TextFormatting;
 
 public class SearchPage extends GuidebookPage {
@@ -35,19 +36,21 @@ public class SearchPage extends GuidebookPage {
             }
         }
 
-        drawStringCenteredNoShadow(fr,results+" results found.",x+width/2,y+10, 0xFF404040);
+        I18n tr = I18n.getInstance();
+
+        drawStringCenteredNoShadow(fr,tr.translateKeyAndFormat("guidebook.section.search.result.found", results),x+width/2,y+10, 0xFF404040);
 
         int offset = y+70;
-        drawStringCenteredNoShadow(fr,"Search Modifiers",x+width/2,offset, 0xFF404040);
-        drawStringNoShadow(fr, TextFormatting.RED+"r:..."+TextFormatting.RESET+": Search for recipes",x+10,offset+=15, 0xFF404040);
-        drawStringNoShadow(fr,TextFormatting.RED+"u:..."+TextFormatting.RESET+": Search for usages",x+10,offset+=10, 0xFF404040);
-        drawStringNoShadow(fr,TextFormatting.RED+"#..."+TextFormatting.RESET+": Search for item group",x+10,offset+=10, 0xFF404040);
-        drawStringNoShadow(fr,TextFormatting.RED+"@namespace"+TextFormatting.RESET+": Search in",x+10,offset+=10, 0xFF404040);
-        drawStringNoShadow(fr,"namespace",x+10,offset+=10, 0xFF404040);
-        drawStringNoShadow(fr,TextFormatting.RED+"@namespace:group"+TextFormatting.RESET+": Search",x+10,offset+=10, 0xFF404040);
-        drawStringNoShadow(fr,"in recipe group",x+10,offset+=10, 0xFF404040);
-        drawStringNoShadow(fr, TextFormatting.RED+"...!"+TextFormatting.RESET+": Strict search",x+10,offset+=10, 0xFF404040);
-        drawStringNoShadow(fr,TextFormatting.RED+"..."+TextFormatting.RESET+": General search",x+10,offset+=15, 0xFF404040);
+        drawStringCenteredNoShadow(fr,tr.translateKey("guidebook.section.search.info.modifiers.title"),x+width/2,offset, 0xFF404040);
+        drawStringNoShadow(fr, tr.translateKey("guidebook.section.search.info.modifiers.1"),x+10,offset+=15, 0xFF404040);
+        drawStringNoShadow(fr,tr.translateKey("guidebook.section.search.info.modifiers.2"),x+10,offset+=10, 0xFF404040);
+        drawStringNoShadow(fr,tr.translateKey("guidebook.section.search.info.modifiers.3"),x+10,offset+=10, 0xFF404040);
+        drawStringNoShadow(fr,tr.translateKey("guidebook.section.search.info.modifiers.4"),x+10,offset+=10, 0xFF404040);
+        drawStringNoShadow(fr,tr.translateKey("guidebook.section.search.info.modifiers.5"),x+10,offset+=10, 0xFF404040);
+        drawStringNoShadow(fr,tr.translateKey("guidebook.section.search.info.modifiers.6"),x+10,offset+=10, 0xFF404040);
+        drawStringNoShadow(fr,tr.translateKey("guidebook.section.search.info.modifiers.7"),x+10,offset+=10, 0xFF404040);
+        drawStringNoShadow(fr,tr.translateKey("guidebook.section.search.info.modifiers.8"),x+10,offset+=10, 0xFF404040);
+        drawStringNoShadow(fr,tr.translateKey("guidebook.section.search.info.modifiers.9"),x+10,offset+=15, 0xFF404040);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/smelting/BlastSmeltingPage.java b/src/main/java/net/minecraft/client/gui/guidebook/smelting/BlastSmeltingPage.java
index abbd48a68..e96a029d4 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/smelting/BlastSmeltingPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/smelting/BlastSmeltingPage.java
@@ -17,6 +17,7 @@ import net.minecraft.core.data.registry.recipe.RecipeSymbol;
 import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryBlastFurnace;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.lang.I18n;
 import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.client.gui.guidebook.GuidebookSlot;
 import org.lwjgl.input.Keyboard;
@@ -72,7 +73,7 @@ public class BlastSmeltingPage
     @Override
     protected void renderForeground(TextureManager re, Font fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
         if(recipes.isEmpty()){
-            drawStringCenteredNoShadow(fr,"No recipes found :(" ,x+width/2,y+height/2,0xFF808080);
+            drawStringCenteredNoShadow(fr, I18n.getInstance().translateKey("guidebook.section.search.error.no_recipes") ,x+width/2,y+height/2,0xFF808080);
         }
         GuidebookSlot mouseOverSlot = null;
         for (GuidebookSlot slot : slots) {
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/smelting/SmeltingPage.java b/src/main/java/net/minecraft/client/gui/guidebook/smelting/SmeltingPage.java
index 3df44593a..b5d971905 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/smelting/SmeltingPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/smelting/SmeltingPage.java
@@ -17,6 +17,7 @@ import net.minecraft.core.data.registry.recipe.RecipeSymbol;
 import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryFurnace;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.lang.I18n;
 import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.client.gui.guidebook.GuidebookSlot;
 import org.lwjgl.input.Keyboard;
@@ -72,7 +73,7 @@ public class SmeltingPage
     @Override
     protected void renderForeground(TextureManager re, Font fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
         if(recipes.isEmpty()){
-            drawStringCenteredNoShadow(fr,"No recipes found :(" ,x+width/2,y+height/2,0xFF808080);
+            drawStringCenteredNoShadow(fr, I18n.getInstance().translateKey("guidebook.section.search.error.no_recipes") ,x+width/2,y+height/2,0xFF808080);
         }
         GuidebookSlot mouseOverSlot = null;
         for (GuidebookSlot slot : slots) {
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/trommeling/TrommelPage.java b/src/main/java/net/minecraft/client/gui/guidebook/trommeling/TrommelPage.java
index 442371d58..cc59a242f 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/trommeling/TrommelPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/trommeling/TrommelPage.java
@@ -20,6 +20,7 @@ import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryTrommel;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.lang.I18n;
 import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.client.gui.guidebook.GuidebookSlot;
 import org.lwjgl.input.Keyboard;
@@ -121,7 +122,7 @@ public class TrommelPage
     @Override
     protected void renderForeground(TextureManager re, Font fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
         if(recipes.isEmpty()){
-            drawStringCenteredNoShadow(fr,"No recipes found :(" ,x+width/2,y+height/2,0xFF808080);
+            drawStringCenteredNoShadow(fr, I18n.getInstance().translateKey("guidebook.section.search.error.no_recipes") ,x+width/2,y+height/2,0xFF808080);
         }
         GuidebookSlot mouseOverSlot = null;
         for (GuidebookSlot slot : slots) {
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/NoteFXEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/NoteFXEntry.java
index 4eddd1569..2fd5d5a61 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/NoteFXEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/NoteFXEntry.java
@@ -34,7 +34,7 @@ public class NoteFXEntry extends ParticleEntry{
 
     @Override
     public void spawnParticle(Minecraft mc, World world, double x, double y, double z) {
-        mc.particleEngine.add(new NoteParticle(world, x, y, z, (double) note / 24D, 0.0D, 0.0D));
+        mc.particleEngine.add(new NoteParticle(world, x, y, z, 0.0, 0.0D, 0.0D, note));
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/render/RenderGlobal.java b/src/main/java/net/minecraft/client/render/RenderGlobal.java
index c17ab72bd..60ad6400f 100644
--- a/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -74,7 +74,7 @@ public class RenderGlobal
     public static IconCoordinate[] breakingAnimation = new IconCoordinate[10];
     static {
         for (int i = 0; i < breakingAnimation.length; i++) {
-            breakingAnimation[i] = TextureRegistry.getTexture("minecraft:block/breaking_" + i);
+            breakingAnimation[i] = TextureRegistry.getTexture("minecraft:block/breaking/" + i);
         }
     }
     public static final int RENDER_CHUNK_SIZE = 16;
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index 6727df9be..6ed2a42b9 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -101,6 +101,7 @@ public class BlockModelDispatcher
         addDispatch(new StandardBlockModel<>(Blocks.BRICK_STONE).withTextures("minecraft:block/brick_stone"));
         addDispatch(new StandardBlockModel<>(Blocks.BRICK_PERMAFROST).withTextures("minecraft:block/brick_permafrost"));
         addDispatch(new StandardBlockModel<>(Blocks.BRICK_IRON).withTextures("minecraft:block/brick_iron"));
+        addDispatch(new StandardBlockModel<>(Blocks.BRICK_STEEL).withTextures("minecraft:block/brick_steel"));
 
         addDispatch(new SlabBlockModel<>(Blocks.SLAB_PLANKS_OAK));
         addDispatch(new SlabBlockModel<>(Blocks.SLAB_COBBLE_STONE));
diff --git a/src/main/java/net/minecraft/client/render/block/model/PaintedDoorBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/PaintedDoorBlockModel.java
index 9ed8bf4c1..790e71498 100644
--- a/src/main/java/net/minecraft/client/render/block/model/PaintedDoorBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/PaintedDoorBlockModel.java
@@ -17,7 +17,7 @@ public class PaintedDoorBlockModel<T extends DoorBlock> extends DoorBlockModel<T
         for (DyeColor c : DyeColor.blockOrderedColors()){
             doorTopTextures[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/door/planks_" + c.colorID + "/top");
             doorBottomTextures[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/door/planks_" + c.colorID + "/bottom");
-            doorBottomTextures[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/door/planks_" + c.colorID + "/frame_top");
+            frameTopTextures[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/door/planks_" + c.colorID + "/frame_top");
         }
     }
     private final boolean isTop;
diff --git a/src/main/java/net/minecraft/client/render/block/model/RedstonePumpkinBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/RedstonePumpkinBlockModel.java
index 4e0b56ceb..343e27387 100644
--- a/src/main/java/net/minecraft/client/render/block/model/RedstonePumpkinBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/RedstonePumpkinBlockModel.java
@@ -7,7 +7,7 @@ import net.minecraft.core.block.RedstonePumpkinBlock;
 import net.minecraft.core.util.helper.Side;
 
 public class RedstonePumpkinBlockModel extends HorizontalRotationBlockModel<RedstonePumpkinBlock> {
-    protected IconCoordinate overlay = TextureRegistry.getTexture("minecraft:block/pumpkin_redstone_overlay");
+    protected IconCoordinate overlay = TextureRegistry.getTexture("minecraft:block/pumpkin_redstone/front_overlay");
     public RedstonePumpkinBlockModel(Block block) {
         super(block);
     }
diff --git a/src/main/java/net/minecraft/client/sound/NamedSoundRepository.java b/src/main/java/net/minecraft/client/sound/NamedSoundRepository.java
index 173e5796d..3e72839e8 100644
--- a/src/main/java/net/minecraft/client/sound/NamedSoundRepository.java
+++ b/src/main/java/net/minecraft/client/sound/NamedSoundRepository.java
@@ -55,7 +55,12 @@ public class NamedSoundRepository extends Registry<SoundEvent> {
                     try {
                         entry.file.getParentFile().mkdirs();
                         entry.file.createNewFile();
-                        StreamUtils.transferDataAndClose(entry.pack.getResourceAsStream(String.format(JAR_SOUNDS_LOCATION_FORMAT, namespace) + entry.name), Files.newOutputStream(entry.file.toPath()));
+                        InputStream in = entry.pack.getResourceAsStream(String.format(JAR_SOUNDS_LOCATION_FORMAT, namespace) + entry.name);
+                        if (in == null) {
+                            thrown.add(new RuntimeException("Could not find data for entry '" + String.format(JAR_SOUNDS_LOCATION_FORMAT, namespace) + entry.name + "'! Unable to copy data!"));
+                            continue;
+                        }
+                        StreamUtils.transferDataAndClose(in, Files.newOutputStream(entry.file.toPath()));
                     } catch (Exception ex) {
                         thrown.add(new RuntimeException("Failed to relocate entry '" + entry.name + "' to '" + entry.file + "'!", ex));
                     }
